## wifi-qr 0.1

=== debian/changelog ===
wifi-qr (0.1-1) unstable; urgency=medium

  * Initial upload.

 -- kokoye2007 <kokoye2007@gmail.com>  Sun, 31 May 2020 08:40:20 +0630

## wifi-qr 0.4

=== Makefile ===
#!/bin/bash

# Makefile for Building, Managing, and Releasing wifi-qr Package

# Define the installation directories
PREFIX ?= /usr/local
BINDIR = $(PREFIX)/bin
APPDIR = $(PREFIX)/share/applications
ICONDIR = $(PREFIX)/share/icons

# Files to install
BIN_FILES = wifi-qr
DESKTOP_FILES = wifi-qr.desktop
ICON_FILES = wifi-qr.svg
METAINFO = wifi-qr.metainfo.xml

# Variables
VERSION := 0.4
DEBIAN_REVISION := 1
DEBIAN_VERSION := $(VERSION)-$(DEBIAN_REVISION)
SOFTWARE := wifi-qr
SOFTFILE := $(SOFTWARE)_$(VERSION)
SOFTTAG := $(SOFTWARE)-$(VERSION)
UPSTREAM_PACKAGE := $(SOFTFILE).org.tar.xz
DEB_FILE := $(SOFTWARE)_$(DEBIAN_VERSION)_all.deb
ARCHIVE := $(SOFTTAG).tar.gz
CHECKSUM_FILE_SHA := CHECKSUMS.sha256
CHECKSUM_FILE_MD5 := CHECKSUMS.md5
CHANGES := $(SOFTFILE)_source.changes
BUILD_DIR := ../BUILD_DIR_$(SOFTWARE)
NOTES := "WiFi-QR update Debian Package"

# Targets
.PHONY: all test-install test-uninstall release-tag build-orig build-changes git-init git-tag git-tag-upload uscan-watch checksum checksum-deb clean debug gbp deb dput

# Default target
all: debug

# Release Tag
release-tag: git-tag git-archive checksum checksum-deb git-tag-upload


# Installation rule
test-install:
	# Install binary file
	install -Dm755 $(BIN_FILES) $(DESTDIR)$(BINDIR)/$(BIN_FILES)
	# Install desktop entry
	install -Dm644 $(DESKTOP_FILES) $(DESTDIR)$(APPDIR)/$(DESKTOP_FILES)
	# Install icon file
	install -Dm644 $(ICON_FILES) $(DESTDIR)$(ICONDIR)/$(ICON_FILES)

# Uninstallation rule
test-uninstall:
	rm -f $(DESTDIR)$(BINDIR)/$(BIN_FILES)
	rm -f $(DESTDIR)$(APPDIR)/$(DESKTOP_FILES)
	rm -f $(DESTDIR)$(ICONDIR)/$(ICON_FILES)

# Target to clean up previous build and create a new Debian orig file
build-orig:
	@echo "Building original source package..."
	rm -rf $(BUILD_DIR) ../$(SOFTFILE).orig.tar.xz*
	mkdir -p $(BUILD_DIR)
	cp -r ./ $(BUILD_DIR)
	cd $(BUILD_DIR) && rm -rf .git && dh_make -s -e kokoye2007 -c gpl3 -p $(SOFTFILE) --createorig -y || echo "DONE"
	gpg --armor --detach-sign ../$(SOFTFILE).orig.tar.xz
	@echo "Original source package created."

# Target to build Debian changes file
build-changes:
	@echo "Building Debian changes file with correct versioning..."
	debuild -S -i -I -sa
	@echo "Changes file created."

# Git repository initialization
git-init:
	@echo "Initializing Git repository..."
	git init
	git add .
	git remote add origin "git@github.com:kokoye2007/$(SOFTWARE).git"
	git remote -v
	@echo "Git repository initialized."

# Create and push a Git tag
git-tag:
	@echo "Creating and pushing Git tag..."
	git tag -s v$(VERSION) -m "Upstream release $(VERSION)"
	git tag -v v$(VERSION)
	git push origin v$(VERSION)
	@echo "Git tag created and pushed."

# Archive, sign, and push the tag
git-archive:
	@echo "Creating Debian-compliant source archive..."
	git archive --prefix=$(SOFTTAG)/ -o ../$(ARCHIVE) v$(VERSION)
	gpg --armor --detach-sign ../$(ARCHIVE)

git-tag-upload:
	@echo "Uploading release archive, Debian package, and checksums..."
	gh release create v$(VERSION) \
		../$(ARCHIVE) \
		../$(ARCHIVE).asc \
		../$(SOFTTAG)_$(CHECKSUM_FILE_SHA) \
		../$(SOFTTAG)_$(CHECKSUM_FILE_MD5) \
		../$(SOFTTAG)_$(CHECKSUM_FILE_SHA).asc \
		../$(SOFTTAG)_$(CHECKSUM_FILE_MD5).asc \
		../$(DEB_FILE) \
		../$(DEB_FILE)_$(CHECKSUM_FILE_SHA) \
		../$(DEB_FILE)_$(CHECKSUM_FILE_MD5) \
		../$(DEB_FILE)_$(CHECKSUM_FILE_SHA).asc \
		../$(DEB_FILE)_$(CHECKSUM_FILE_MD5).asc \
		--title "$(SOFTTAG)" \
		--notes "Release $(SOFTTAG) with Debian package"
	@echo "GitHub release updated with Debian package and checksums."

# Run uscan to check for new upstream versions
uscan-watch:
	@echo "Running uscan to check for upstream updates..."
	uscan --no-download --verbose --debug
	@echo "uscan check completed."

# Generate checksums for build artifacts
# checksum: $(ARCHIVE)
checksum:
	@echo "Generating SHA256 and MD5 checksums for $(ARCHIVE)..."
	sha256sum ../$(ARCHIVE)* > ../$(SOFTTAG)_$(CHECKSUM_FILE_SHA)
	md5sum ../$(ARCHIVE)* > ../$(SOFTTAG)_$(CHECKSUM_FILE_MD5)
	gpg --armor --detach-sign ../$(SOFTTAG)_$(CHECKSUM_FILE_SHA)
	gpg --armor --detach-sign ../$(SOFTTAG)_$(CHECKSUM_FILE_MD5)
	@echo "Checksums generated and signed: $(CHECKSUM_FILE_SHA) and $(CHECKSUM_FILE_MD5)"

# Generate checksums for DEB file
checksum-deb:
	@echo "Generating SHA256 and MD5 checksums for $(DEB_FILE)..."
	sha256sum ../$(DEB_FILE) > ../$(DEB_FILE)_$(CHECKSUM_FILE_SHA)
	md5sum ../$(DEB_FILE) >    ../$(DEB_FILE)_$(CHECKSUM_FILE_MD5)
	gpg --armor --detach-sign  ../$(DEB_FILE)_$(CHECKSUM_FILE_SHA)
	gpg --armor --detach-sign  ../$(DEB_FILE)_$(CHECKSUM_FILE_MD5)
	@echo "Checksums generated and signed: $(DEB_FILE)_$(CHECKSUM_FILE_SHA) and $(DEB_FILE)_$(CHECKSUM_FILE_MD5)"

# Clean up build artifacts
clean:
	@echo "Cleaning up build artifacts..."
	rm -rf $(BUILD_DIR) *.tar.gz *.orig.tar.xz $(CHECKSUM_FILE_SHA)* $(CHECKSUM_FILE_MD5)* $(CHANGES)
	@echo "Clean-up complete."

# Output current state of variables for debugging
debug:
	@echo "SOFTWARE: $(SOFTWARE)"
	@echo "VERSION: $(VERSION)"
	@echo "SOFTFILE: $(SOFTFILE)"
	@echo "SOFTTAG: $(SOFTTAG)"
	@echo "BUILD_DIR: $(BUILD_DIR)"
	@echo "ARCHIVE: $(ARCHIVE)"
	@echo "CHECKSUM_FILE_SHA: $(CHECKSUM_FILE_SHA)"
	@echo "CHECKSUM_FILE_MD5: $(CHECKSUM_FILE_MD5)"
	@echo "CHANGES: $(CHANGES)"
	@echo "UPSTREAM_PACKAGE: $(UPSTREAM_PACKAGE)"

# Git-buildpackage for Debian package building
gbp:
	@echo "Running Git-buildpackage..."
	gbp buildpackage --git-tag-only --git-ignore-branch
	@echo "Git-buildpackage complete."

# Build Debian binary package
deb:
	@echo "Building Debian binary package..."
	debuild -b
	@echo "Debian binary package built."

# Upload package to Debian mentors
dput:
	@echo "Uploading package to mentors..."
	dput -f mentors ../$(CHANGES)
	@echo "Package uploaded to mentors."

## wifi-qr 0.2

=== debian/changelog ===
wifi-qr (0.2-2) unstable; urgency=medium

  * Package description update. (Closes: #989034)
  * QR Code File Scan

 -- kokoye2007 <kokoye2007@gmail.com>  Wed, 27 Apr 2022 17:11:19 +0630

wifi-qr (0.2-1) unstable; urgency=medium

  * Shellcheck and close issue #9

 -- kokoye2007 <kokoye2007@gmail.com>  Thu, 18 Jun 2020 15:36:47 +0630

=== debian/control ===
Source: wifi-qr
Section: utils
Priority: optional
Maintainer: kokoye2007 <kokoye2007@gmail.com>
Build-Depends: debhelper-compat (= 13)
Rules-Requires-Root: no
Standards-Version: 4.6.0.1
Homepage: https://github.com/kokoye2007/wifi-qr
Vcs-Git: https://github.com/kokoye2007/wifi-qr.git
Vcs-Browser: https://github.com/kokoye2007/wifi-qr

Package: wifi-qr
Architecture: all
Depends: ${misc:Depends}, zenity, qrencode, zbar-tools
Description: WiFi password share via QR codes
 Shares WiFi SSID and password via a QR code.
 Generate a QR code of a WiFi network with its password.
 Scan QR codes and easily connect to WiFi Networks.
 .
 For Android, OS version 10 and above is supported.
 .
 For iOS, the Shortcut app supports generating WiFi QR codes.

=== debian/watch ===
version=4

opts=pgpsigurlmangle=s/archive\/(\d\S+)\.tar\.gz/tags\/download\/$1\/$1\.tar\.gz\.asc/ \
  https://github.com/kokoye2007/wifi-qr/releases/latest .*/(\d\S+)\.tar\.gz

## wifi-qr 0.3

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: kokoye2007 <kokoye2007@gmail.com>
 Build-Depends: debhelper-compat (= 13)
 Rules-Requires-Root: no
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/kokoye2007/wifi-qr
 Vcs-Git: https://github.com/kokoye2007/wifi-qr.git
 Vcs-Browser: https://github.com/kokoye2007/wifi-qr

=== debian/watch ===
version=4
opts="searchmode=plain,\
  pgpmode=auto" \
https://api.github.com/repos/kokoye2007/@PACKAGE@/releases?per_page=50 \
https://api.github.com/repos/[^/]+/[^/]+/tarball/v?@ANY_VERSION@

## wifi-qr 0.4

=== debian/changelog ===
wifi-qr (0.4-1) unstable; urgency=medium

  * New upstream release (0.4)
  * Extend debian/source ignore patterns
    - exclude README and Screenshots
    - exclude wifi-qr.spec
  * Update debian/copyright
    - Bump copyright year to 2024
    - Add wifi-qr.metainfo.xml with CC0-1.0 license
  * Update debian/control
    - Modify dependency from zenity to "zenity | kdialog"
  * Update debian/watch
    - Update url pattern for pgp asc.

 -- kokoye2007 <kokoye2007@gmail.com>  Thu, 19 Dec 2024 01:09:13 +1100

wifi-qr (0.3-1) unstable; urgency=medium

  * New upstream release (0.3).
  * #18 Xiaomi QR code is parsed incorrectly.
  * #17 QR issue when the name and SSID differ.
  * #16 QR issue when the password has special characters.
  * #15 QR issue when the SSID has special characters.
  * #12 Password with special characters needs to be unquoted.

 -- kokoye2007 <kokoye2007@gmail.com>  Sat, 30 Sep 2023 17:30:20 +1000

=== debian/watch ===
version=4
opts="searchmode=plain,\
uversionmangle=s/^(release|v)?\.//;s/(rc|b)/~$1/,\
pgpsigurlmangle=s/$/\.asc/" \
https://api.github.com/repos/kokoye2007/@PACKAGE@/releases \
https://github.com/kokoye2007/@PACKAGE@/releases/download/v?[\d.]+/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
